WITH
  update_last_trade
    AS (
      UPDATE
        last_trade
      SET
        lt_vol = lt_vol + $2, lt_price = $3:::FLOAT8::DECIMAL, lt_dts = $10
      WHERE
        lt_s_symb = $1
      RETURNING
        NULL
    ),
  request_list
    AS (
      SELECT
        tr_t_id, tr_bid_price::FLOAT8, tr_tt_id, tr_qty
      FROM
        trade_request
      WHERE
        tr_s_symb = $1
        AND (
            (tr_tt_id = $6 AND tr_bid_price >= $4:::FLOAT8::DECIMAL)
            OR (tr_tt_id = $7 AND tr_bid_price <= $5:::FLOAT8::DECIMAL)
            OR (tr_tt_id = $8 AND tr_bid_price >= $4:::FLOAT8::DECIMAL)
          )
    ),
  delete_trade_request
    AS (
      DELETE FROM trade_request WHERE tr_t_id IN (SELECT tr_t_id FROM request_list) RETURNING NULL
    ),
  insert_trade_history
    AS (
      INSERT
      INTO
        trade_history (th_t_id, th_dts, th_st_id)
      (SELECT tr_t_id, $10, $9 FROM request_list)
      RETURNING
        NULL
    ),
  update_trade_submitted
    AS (
      UPDATE
        trade
      SET
        t_st_id = $9, t_dts = $10
      WHERE
        t_id IN (SELECT tr_t_id FROM request_list)
      RETURNING
        NULL
    )
SELECT
  *
FROM
  request_list

-- Arguments:
--  $1: 'IDEVPRC-b'
--  $2: 375
--  $3: 26.28
--  $4: 26.28
--  $5: 26.28
--  $6: 'TSL'
--  $7: 'TLS'
--  $8: 'TLB'
--  $9: 'SBMT'
--  $10: '2022-10-21 17:31:54.994563'
